Debian Bug report logs - #648148
autopkgtest: Support running as user

version graph

Package: autopkgtest; Maintainer for autopkgtest is Autopkgtest team <autopkgtest-devel@lists.alioth.debian.org>; Source for autopkgtest is src:autopkgtest.

Reported by: Martin Pitt <martin.pitt@ubuntu.com>

Date: Wed, 9 Nov 2011 07:54:01 UTC

Severity: wishlist

Found in version autopkgtest/2.0.1

Fixed in version autopkgtest/2.5

Done: Martin Pitt <mpitt@debian.org>

Bug is archived. No further changes may be made.

Toggle useless messages

View this report as an mbox folder, status mbox, maintainer mbox


Report forwarded to debian-bugs-dist@lists.debian.org, Autopkgtest team <autopkgtest-devel@lists.alioth.debian.org>:
Bug#648148; Package autopkgtest. (Wed, 09 Nov 2011 07:54:05 GMT) Full text and rfc822 format available.

Acknowledgement sent to Martin Pitt <martin.pitt@ubuntu.com>:
New Bug report received and forwarded. Copy sent to Autopkgtest team <autopkgtest-devel@lists.alioth.debian.org>. (Wed, 09 Nov 2011 07:54:06 GMT) Full text and rfc822 format available.

Message #5 received at submit@bugs.debian.org (full text, mbox):

From: Martin Pitt <martin.pitt@ubuntu.com>
To: Debian BTS Submit <submit@bugs.debian.org>
Subject: autopkgtest: Support running as user
Date: Wed, 9 Nov 2011 08:50:15 +0100
[Message part 1 (text/plain, inline)]
Package: autopkgtest
Severity: wishlist
Version: 2.0.1
Tags: patch
User: ubuntu-devel@lists.ubuntu.com
Usertags: origin-ubuntu ubuntu-patch precise

Hello,

for testing build recipes I'd like to skip all the apt parts and run
adt-run as normal user. This currently fails because it always tries
to set up apt.

Attached patch skips the apt parts if running as non-root and prints a
warning. The second hunk is necessary because opts.user defaults to
'', not to None, and thus "opts.user is not None" is always True and
it always tries to call su (which doesn't work as normal user).

Thanks,

Martin

-- 
Martin Pitt                        | http://www.piware.de
Ubuntu Developer (www.ubuntu.com)  | Debian Developer  (www.debian.org)
[autopkgtest.run-as-user.patch (text/x-diff, attachment)]
[signature.asc (application/pgp-signature, inline)]

Information forwarded to debian-bugs-dist@lists.debian.org, Autopkgtest team <autopkgtest-devel@lists.alioth.debian.org>:
Bug#648148; Package autopkgtest. (Wed, 25 Apr 2012 18:03:15 GMT) Full text and rfc822 format available.

Message #8 received at 648148@bugs.debian.org (full text, mbox):

From: Jakub Wilk <jwilk@debian.org>
To: 648148@bugs.debian.org
Cc: Martin Pitt <martin.pitt@ubuntu.com>
Subject: Re: Bug#648148: autopkgtest: Support running as user
Date: Wed, 25 Apr 2012 20:02:38 +0200
* Martin Pitt <martin.pitt@ubuntu.com>, 2011-11-09, 08:50:
>-	if 'needs-root' not in t.restriction_names and opts.user is not None:
>+	if 'needs-root' not in t.restriction_names and opts.user:
> 		tfl = ['su',opts.user,'-c',tf]
> 		tmpdir = '%s%s-tmpdir' % (testbed.scratch.read(True), t.what)
> 		script = 'rm -rf -- "$1"; mkdir -- "$1"'

After applying this hunk, TMPDIR variable is no longer exposed to test 
scripts, even when adt-run is run as root.

(Setting TMPDIR was a mistake in the first place IMHO. This variable in 
POSIX has completely different semantics. Running a scripts that relied 
on the feature outside adt-run might lead to security holes.)

-- 
Jakub Wilk




Information forwarded to debian-bugs-dist@lists.debian.org, Autopkgtest team <autopkgtest-devel@lists.alioth.debian.org>:
Bug#648148; Package autopkgtest. (Mon, 11 Jun 2012 00:57:02 GMT) Full text and rfc822 format available.

Acknowledgement sent to Ian Jackson <ijackson@chiark.greenend.org.uk>:
Extra info received and forwarded to list. Copy sent to Autopkgtest team <autopkgtest-devel@lists.alioth.debian.org>. (Mon, 11 Jun 2012 00:57:02 GMT) Full text and rfc822 format available.

Message #13 received at 648148@bugs.debian.org (full text, mbox):

From: Ian Jackson <ijackson@chiark.greenend.org.uk>
To: 648148@bugs.debian.org, Jakub Wilk <jwilk@debian.org>, Martin Pitt <martin.pitt@ubuntu.com>
Subject: autopkgtest: Support running as user
Date: Mon, 11 Jun 2012 01:55:08 +0100
tags 648148 - patch
thanks

Hi.  Martin, you wrote:
> for testing build recipes I'd like to skip all the apt parts and run
> adt-run as normal user. This currently fails because it always tries
> to set up apt.

I agree that this would be sensible.  But I think the right answer is
to make this depend on the `root-on-testbed' testbed capability, not
on opts.user.

Also, Jakub, you wrote:
> (Setting TMPDIR was a mistake in the first place IMHO. This variable
> in POSIX has completely different semantics. Running a scripts that
> relied on the feature outside adt-run might lead to security holes.)

I agree.  However I'm not sure that we can just withdraw this.  There
may be tests depending on it, and it's documented in the spec.

I'm tempted to suggest:
 - Invent a new variable ADT_TMP that does what TMPDIR is specified to do.
 - Continue to set TMPDIR, but to a subdirectory of $ADT_TMP but only
   for tests which don't run as root on the testbed.
 - Change the spec to deprecate use of TMPDIR.
 - Change the manpages not to refer to TMPDIR any more.

What do you think ?

Thanks,
Ian.




Removed tag(s) patch. Request was from Ian Jackson <ijackson@chiark.greenend.org.uk> to control@bugs.debian.org. (Mon, 11 Jun 2012 00:57:04 GMT) Full text and rfc822 format available.

Information forwarded to debian-bugs-dist@lists.debian.org, Autopkgtest team <autopkgtest-devel@lists.alioth.debian.org>:
Bug#648148; Package autopkgtest. (Tue, 12 Jun 2012 14:48:03 GMT) Full text and rfc822 format available.

Message #18 received at 648148@bugs.debian.org (full text, mbox):

From: Jakub Wilk <jwilk@debian.org>
To: 648148@bugs.debian.org
Cc: Martin Pitt <martin.pitt@ubuntu.com>
Subject: Re: autopkgtest: Support running as user
Date: Tue, 12 Jun 2012 16:44:33 +0200
* Ian Jackson <ijackson@chiark.greenend.org.uk>, 2012-06-11, 01:55:
>Also, Jakub, you wrote:
>>(Setting TMPDIR was a mistake in the first place IMHO. This variable 
>>in POSIX has completely different semantics. Running a scripts that 
>>relied on the feature outside adt-run might lead to security holes.)
>
>I agree. However I'm not sure that we can just withdraw this. There 
>may be tests depending on it, and it's documented in the spec.
>
>I'm tempted to suggest:
>- Invent a new variable ADT_TMP that does what TMPDIR is specified to 
>do.
>- Continue to set TMPDIR, but to a subdirectory of $ADT_TMP but only 
>for tests which don't run as root on the testbed.

I don't think I understand this point. Why a subdirectory? Couldn't 
TMPDIR and ADT_TMP have the same value? Why special-case tests that 
don't run as root?

>- Change the spec to deprecate use of TMPDIR.
>- Change the manpages not to refer to TMPDIR any more.
>
>What do you think ?

I second the idea of deprecating TMPDIR and introducing another variable 
for this purpose.

-- 
Jakub Wilk




Information forwarded to debian-bugs-dist@lists.debian.org, Autopkgtest team <autopkgtest-devel@lists.alioth.debian.org>:
Bug#648148; Package autopkgtest. (Wed, 13 Jun 2012 15:45:03 GMT) Full text and rfc822 format available.

Acknowledgement sent to Martin Pitt <mpitt@debian.org>:
Extra info received and forwarded to list. Copy sent to Autopkgtest team <autopkgtest-devel@lists.alioth.debian.org>. (Wed, 13 Jun 2012 15:45:03 GMT) Full text and rfc822 format available.

Message #23 received at 648148@bugs.debian.org (full text, mbox):

From: Martin Pitt <mpitt@debian.org>
To: 648148@bugs.debian.org, Martin Pitt <martin.pitt@ubuntu.com>
Subject: Re: autopkgtest: Support running as user
Date: Wed, 13 Jun 2012 17:41:17 +0200
Hello,

Jakub Wilk [2012-06-12 16:44 +0200]:
> >- Change the spec to deprecate use of TMPDIR.
> >- Change the manpages not to refer to TMPDIR any more.
> >
> >What do you think ?
> 
> I second the idea of deprecating TMPDIR and introducing another
> variable for this purpose.

I also second this ("thirded"? :-) ).

Setting $TMPDIR leads to strange effects like this:

  File "/usr/lib/python3.2/tempfile.py", line 216, in _mkstemp_inner
    fd = _os.open(file, flags, 0o600)
OSError: [Errno 13] Permission denied: '/tmp/tmp.daOkZV19Dm/ubtree0-build/tmpdir/tmp231sct'

This is a package build which runs tests during build, with $TMPDIR
set. As this initially gets created as root, the test suite is
apparently not able to access it.

Thanks,

Martin
-- 
Martin Pitt                        | http://www.piware.de
Ubuntu Developer (www.ubuntu.com)  | Debian Developer  (www.debian.org)




Information forwarded to debian-bugs-dist@lists.debian.org, Autopkgtest team <autopkgtest-devel@lists.alioth.debian.org>:
Bug#648148; Package autopkgtest. (Fri, 15 Jun 2012 00:24:05 GMT) Full text and rfc822 format available.

Acknowledgement sent to Ian Jackson <ijackson@chiark.greenend.org.uk>:
Extra info received and forwarded to list. Copy sent to Autopkgtest team <autopkgtest-devel@lists.alioth.debian.org>. (Fri, 15 Jun 2012 00:24:05 GMT) Full text and rfc822 format available.

Message #28 received at 648148@bugs.debian.org (full text, mbox):

From: Ian Jackson <ijackson@chiark.greenend.org.uk>
To: Martin Pitt <mpitt@debian.org>, 648148@bugs.debian.org
Cc: Martin Pitt <martin.pitt@ubuntu.com>
Subject: Re: Bug#648148: autopkgtest: Support running as user
Date: Fri, 15 Jun 2012 01:21:42 +0100
Martin Pitt writes ("Bug#648148: autopkgtest: Support running as user"):
> Jakub Wilk [2012-06-12 16:44 +0200]:
> > I second the idea of deprecating TMPDIR and introducing another
> > variable for this purpose.
> 
> I also second this ("thirded"? :-) ).
> 
> Setting $TMPDIR leads to strange effects like this:
> 
>   File "/usr/lib/python3.2/tempfile.py", line 216, in _mkstemp_inner
>     fd = _os.open(file, flags, 0o600)
> OSError: [Errno 13] Permission denied: '/tmp/tmp.daOkZV19Dm/ubtree0-build/tmpdir/tmp231sct'

This is a bug, I think.  The directory should be available to the test
user.

> This is a package build which runs tests during build, with $TMPDIR
> set. As this initially gets created as root, the test suite is
> apparently not able to access it.

I will see if I can fix this now.

Ian.




Information forwarded to debian-bugs-dist@lists.debian.org, Autopkgtest team <autopkgtest-devel@lists.alioth.debian.org>:
Bug#648148; Package autopkgtest. (Fri, 15 Jun 2012 00:39:03 GMT) Full text and rfc822 format available.

Acknowledgement sent to Ian Jackson <ijackson@chiark.greenend.org.uk>:
Extra info received and forwarded to list. Copy sent to Autopkgtest team <autopkgtest-devel@lists.alioth.debian.org>. (Fri, 15 Jun 2012 00:39:03 GMT) Full text and rfc822 format available.

Message #33 received at 648148@bugs.debian.org (full text, mbox):

From: Ian Jackson <ijackson@chiark.greenend.org.uk>
To: Martin Pitt <mpitt@debian.org>, 648148@bugs.debian.org
Cc: Martin Pitt <martin.pitt@ubuntu.com>
Subject: Re: Bug#648148: autopkgtest: Support running as user
Date: Fri, 15 Jun 2012 01:37:02 +0100
Martin Pitt writes ("Bug#648148: autopkgtest: Support running as user"):
> Jakub Wilk [2012-06-12 16:44 +0200]:
> > >- Change the spec to deprecate use of TMPDIR.
> > >- Change the manpages not to refer to TMPDIR any more.
> > >
> > >What do you think ?
> > 
> > I second the idea of deprecating TMPDIR and introducing another
> > variable for this purpose.
> 
> I also second this ("thirded"? :-) ).

I'm going to provide, and document that we provide, ADTTMP.

I would still like to provide TMPDIR for the build scripts but it
ought to have the right permissions.  I will sort this out.

Ian.




Information forwarded to debian-bugs-dist@lists.debian.org, Autopkgtest team <autopkgtest-devel@lists.alioth.debian.org>:
Bug#648148; Package autopkgtest. (Wed, 20 Nov 2013 11:39:05 GMT) Full text and rfc822 format available.

Acknowledgement sent to Martin Pitt <mpitt@debian.org>:
Extra info received and forwarded to list. Copy sent to Autopkgtest team <autopkgtest-devel@lists.alioth.debian.org>. (Wed, 20 Nov 2013 11:39:05 GMT) Full text and rfc822 format available.

Message #38 received at 648148@bugs.debian.org (full text, mbox):

From: Martin Pitt <mpitt@debian.org>
To: Ian Jackson <ijackson@chiark.greenend.org.uk>, 648148@bugs.debian.org
Subject: Re: Bug#648148: autopkgtest: Support running as user
Date: Wed, 20 Nov 2013 12:36:01 +0100
[Message part 1 (text/plain, inline)]
tag 648148 pending
thanks

Hello all,

Ian Jackson [2012-06-11  1:55 +0100]:
> Hi.  Martin, you wrote:
> > for testing build recipes I'd like to skip all the apt parts and run
> > adt-run as normal user. This currently fails because it always tries
> > to set up apt.
> 
> I agree that this would be sensible.  But I think the right answer is
> to make this depend on the `root-on-testbed' testbed capability, not
> on opts.user.

As for the apt parts, autopkgtest was already fixed to not do the
binary publishing unless it actually had something to publish. As for
installing test depends, running as user with -null only really works
for the trivial case of empty Depends:; arguably this isn't very
interesting, but if we can't install dependencies then we can't run
the test. As a corner case, it should be possible to detect that all
dependencies are already installed and we don't install built
binaries, but pbuilder-satisfy-dependencies doesn't support this.

In short, in this situation it is easier to just run debian/tests/foo
by hand and skip adt-run completely. In all others, it's not a biggie
to run it with the -schroot runner (which works fine as user) or
through sudo, so I don't care enough about this corner case to write
lots of code around it.

One remaining wart is this:

$ adt-run ./ -d  --- adt-virt-null
[...]
adt-run: & tree0t-s: [----------------------------------------
su: must be run from a terminal
adt-run1: testbed executing test finished with exit status 1

That's easy to fix with what you mention (bind it to root-on-testbed):
  https://gitorious.org/autopkgtest/autopkgtest/commit/7d191312
  (temporary clone of the git repo while alioth is offline)

That's about as far as I'd like to go, so closing with above commit.

Martin
-- 
Martin Pitt                        | http://www.piware.de
Ubuntu Developer (www.ubuntu.com)  | Debian Developer  (www.debian.org)
[signature.asc (application/pgp-signature, inline)]

Added tag(s) pending. Request was from Martin Pitt <mpitt@debian.org> to control@bugs.debian.org. (Wed, 20 Nov 2013 11:39:07 GMT) Full text and rfc822 format available.

Reply sent to Martin Pitt <mpitt@debian.org>:
You have taken responsibility. (Mon, 25 Nov 2013 06:51:05 GMT) Full text and rfc822 format available.

Notification sent to Martin Pitt <martin.pitt@ubuntu.com>:
Bug acknowledged by developer. (Mon, 25 Nov 2013 06:51:05 GMT) Full text and rfc822 format available.

Message #45 received at 648148-close@bugs.debian.org (full text, mbox):

From: Martin Pitt <mpitt@debian.org>
To: 648148-close@bugs.debian.org
Subject: Bug#648148: fixed in autopkgtest 2.5
Date: Mon, 25 Nov 2013 06:48:27 +0000
Source: autopkgtest
Source-Version: 2.5

We believe that the bug you reported is fixed in the latest version of
autopkgtest, which is due to be installed in the Debian FTP archive.

A summary of the changes between this version and the previous one is
attached.

Thank you for reporting the bug, which will now be closed.  If you
have further comments please address them to 648148@bugs.debian.org,
and the maintainer will reopen the bug report if appropriate.

Debian distribution maintenance software
pp.
Martin Pitt <mpitt@debian.org> (supplier of updated autopkgtest package)

(This message was generated automatically at their request; if you
believe that there is a problem with it please contact the archive
administrators by mailing ftpmaster@ftp-master.debian.org)


-----BEGIN PGP SIGNED MESSAGE-----
Hash: SHA256

Format: 1.8
Date: Mon, 25 Nov 2013 07:31:22 +0100
Source: autopkgtest
Binary: autopkgtest autopkgtest-xenlvm
Architecture: source all
Version: 2.5
Distribution: unstable
Urgency: low
Maintainer: Autopkgtest team <autopkgtest-devel@lists.alioth.debian.org>
Changed-By: Martin Pitt <mpitt@debian.org>
Description: 
 autopkgtest - automatic as-installed testing for Debian packages
 autopkgtest-xenlvm - Xen/LVM2 based testbed snapshot system
Closes: 648148 698551 729790 729791
Changes: 
 autopkgtest (2.5) unstable; urgency=low
 .
   Behaviour changes:
   * Drop --output-dir option. It has never really been useful as it only works
     for paths in the testbed, has a confusing semantics, is redundant with
     --tmp-dir, and currently even crashes adt-run. (Closes: #729790)
   * Rename --tmp-dir option to --output-dir, as its main purpose is really to
     collect test artifacts. Keep --tmp-dir alias for backwards compatibility.
   * Drop --override-control option. It complicates the code too much for its
     very limited utility, and it was not even documented in the manpage.
   * Drop --paths-testbed (and thus also --paths-host) options. There is no
     use case for them.
   * Add short options for common command line options: -B for
     --no-built-binaries, -o for --output-dir, -l for --log-file,
     -u for --user.
   * Clean up uninteresting files from --output-dir directory.
   * Tests which want to create additional artifacts can now put them into the
     $ADT_ARTIFACTS directory. When using the --output-dir option, they will be
     copied into <outputdir>/artifacts/. Document this new feature in
     README.package-tests. (LP: #1137763)
 .
   Packaging changes:
   * Drop obsolete autodebtest Conflicts/Replaces.
   * Update copyright years.
   * Bump Standards-Version to 3.9.5. No changes necessary.
   * CREDITS: Add myself.
   * Makefile: Support $DESTDIR, like automake.
   * Adjust sharedir* defaults in settings.make to what we actually want, and
     drop their overrides in debian/rules
   * Move debian/rules to using dh.
   * Add ./run-from-checkout script to run adt-run from the git checkout or
     source package. Change tests/adt-run to use it.
   * Add tests/run-parallel to run tests for different runners in parallel.
 .
   Bug fixes:
   * Fix OSError crash if --output-dir/--tmp-dir does not exist.
     (Closes: #729791)
   * Pass line number to Test constructor argument, to be able to report proper
     errors instead of crashing. (side issue in #698551)
   * Fix exit code for "Unsupported" error.
   * When encountering an unsupported test, report only this test as skipped,
     not all the others in the same "Tests:" stanza.
   * README.package-tests: Test names must not contain '/'. (Closes: #698551)
   * Create manpage for adt-virt-schroot. (first half of #695974)
   * Fix "su: must be run from a terminal" failure when running as user and
     testbed doesn't provide root-on-testbed. (Closes: #648148)
   * Add bandaid to avoid mixing order of stdout and stderr in the log file
     when reporting results.
 .
   Code cleanup:
   * Simplify logging by dropping the explicit functions for writing to stderr
     plus log, and instead set up pipes so that the whole stdout/stderr will be
     tee'd into the logfile.
   * Replace the usage of the AutoFile classes (which are underdocumented,
     magic, and hard to understand) with a more explicit and much simpler
     TestbedPath class.
   * Stop installing the redundant /etc/apt/apt.conf.d/90autopkgtest into
     testbeds, and simplify invocation of apt-get.
 .
   New test cases:
   * Access /dev/std{out,err} in a non-root test, like the "mafft" autopkgtest
     does.
   * --log-file test cases for chroot and schroot runners.
   * schroot and LXC runner test cases for installing built binaries.
   * --output-dir in schroot runner with complete package build.
   * Recommends do not get installed by default.
   * Test case with '/' in the name.
   * --user option for schroot and null runners.
   * breaks-testbed restriction for all runners.
Checksums-Sha1: 
 167187f8f10f4ab9c97bf769240cce2be254ce5d 1745 autopkgtest_2.5.dsc
 c0adbe8bc994c98a808821ce21965ba65d00145e 91702 autopkgtest_2.5.tar.gz
 e029be7ec98f9ccbb501b82457a54d118c34e94c 68334 autopkgtest_2.5_all.deb
 8d02de92c214780bfb2e48a0574e00514220b40a 30030 autopkgtest-xenlvm_2.5_all.deb
Checksums-Sha256: 
 8cac64d800223f27fb03fca519898b596b3bb0f13d6d516084dc57c49fd60e7e 1745 autopkgtest_2.5.dsc
 866b0a8f312797d58e310bbbcaf96e463c372272285d1b7463ac130ef7708399 91702 autopkgtest_2.5.tar.gz
 cce31e59ec5fd3f038a34914000acd2dd863141a9804b9543e7dea25d7ee172a 68334 autopkgtest_2.5_all.deb
 b62ac19fd08ba8c05febb6de01407afec3a34f1283bb938ac1b4260396757c50 30030 autopkgtest-xenlvm_2.5_all.deb
Files: 
 fd4b9b26626ca8d8bcb16a1e69663d99 1745 devel optional autopkgtest_2.5.dsc
 fa46a4c9380831ce672cc7613c88540b 91702 devel optional autopkgtest_2.5.tar.gz
 440d255bdf867d1c5f91f67c3b2a5d6a 68334 devel optional autopkgtest_2.5_all.deb
 fbc9c54284d6ba21a8d438b97fcfa74a 30030 devel optional autopkgtest-xenlvm_2.5_all.deb

-----BEGIN PGP SIGNATURE-----
Version: GnuPG v1.4.15 (GNU/Linux)

iQIcBAEBCAAGBQJSkvH4AAoJENFO8V2v4RNHM0cQAJHNzRGk6wtrd/j4eFgNAzZD
s+Da5KzMEO4MPPMwfEwAAcMdm6ziMghzJqRzieThIUJjoCwm1qzprPKVrS49CKO5
JzB/rtzy9a/H7aMmJ/c92c5aPiIX/35V/LdnomrsiLNZG1JLg8S71LUh8xhQJdQP
7J7SU756pivpLIgZllQycaviRkTplIBP1iYJNxkCzo/lSS9y6oKMauTdOvNhpFhw
I66Tlpl1Fa0gdu9AkKxk3rGftpZ117dsiOIu/hw/FyfPzc4KNXm/a7/6hpNMXU4c
uIr4YvuEWrh9Evcp5tVq/HsuCfeGBrq95VcC5a1Kqwk52nqDrgdWQVUa6lsS2j81
6r8/nKR24grNfefo3YZtAEzqdPVCOZEtZDvc9Xj0rGMvIUXlKRzw1bCtcWX2boG6
CCdz1cYywV6UpkDPFWWIyEvJXqrnMrnn+EFe3hSjtubXm/PY5hC7qBsMedaWtNRT
//UQ8+x/qaT4aXzKW6uhMKv8rIl5l8CJK3YnwyD6OpLPG10xghhpeBhROx7OkgyY
ndzWHCfGkatnAdJqVSNU8D/6xU7adDMW9ygG491WZRM8uduS7I9vgbw/J7A9OCHr
5ZgcHyxGXwfeuO4g8jGVmfdhjcBjeRe4oUAqZ1kyVhOQxpf0GZefvMvgAvRnHkXB
P/3p/IAWV8cxhsDVvPYl
=U3V+
-----END PGP SIGNATURE-----




Bug archived. Request was from Debbugs Internal Request <owner@bugs.debian.org> to internal_control@bugs.debian.org. (Tue, 24 Dec 2013 07:30:38 GMT) Full text and rfc822 format available.

Send a report that this bug log contains spam.


Debian bug tracking system administrator <owner@bugs.debian.org>. Last modified: Thu Apr 24 07:11:54 2014; Machine Name: buxtehude.debian.org

Debian Bug tracking system
Copyright (C) 1999 Darren O. Benham, 1997,2003 nCipher Corporation Ltd, 1994-97 Ian Jackson.